// RTF parser declarations

int ecRtfParse(FILE *fp);
int ecPushRtfState(void);
int ecPopRtfState(void);
int ecParseRtfKeyword(FILE *fp);
int ecParseChar(int c,int param);
int ecTranslateKeyword(char *szKeyword, int param, char fParam);
int ecPrintChar(int ch,int param);
int ecEndGroupAction(RDS rds);
int ecApplyPropChange(IPROP iprop, int val);
int ecChangeDest(IDEST idest);
int ecParseSpecialKeyword(IPFN ipfn);
int ecParseSpecialProperty(IPROP iprop, int val);
int ecParseHexByte(void);

int fonttablechar(int ch);
int fonttablefamily(int val);
int fonttablemember(int val);
int fonttablestart(void);
int fonttableend(void);

extern int deffont;


int colourtablevalue(int iprop,int val);
int colourtablestart(void);
int colourtableend(void);
int colourtablechar(int ch);


int tabschar(int ch);
int tabsvalue(int iprop,int val);
int tabscodestart(void);
int tabscodeend(void);



int styletablestart(void);
int styletableend(void);
int styletablechar(int ch);
int styletablemember(int type,int val);
void styleadd(int iprop,int val);
void stylerem(int iprop);
void stylechange(void);

int keycodestart(void);
int keycodeend(void);
int keycodemember(int type,int val);
int keycodechar(int ch);

int pictstart(void);
int pictend(void);
int ecPictChar(int ch);
int ecPict(IPROP iprop,int val);



// RTF variable declarations

extern int cGroup;
extern RDS rds;
extern RIS ris;

extern CHP chp;
extern PAP pap;
extern SEP sep;
extern DOP dop;

extern SAVE *psave;
extern long cbBin;
extern long lParam;
extern bool fSkipDestIfUnk;
extern int  unicodeskip;
extern int  risUnicode;

// RTF parser error codes

#define ecOK 0                      // Everything's fine!
#define ecStackUnderflow    1       // Unmatched '}'
#define ecStackOverflow     2       // Too many '{' -- memory exhausted
#define ecUnmatchedBrace    3       // RTF ended during an open group.
#define ecInvalidHex        4       // invalid hex character found in data
#define ecBadTable          5       // RTF table (sym or prop) invalid
#define ecAssertion         6       // Assertion failure
#define ecEndOfFile         7       // End of file reached while reading RTF
